{
   muu TrueColor library for TMT Pascal - Clear example
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

USES mArea,mFormat,mSurface,mConsole,mTarga,mc_VESA,mc_Wrap,Nova,CRT,Error,Memory;

// {$DEFINE debug_wrapper}  // enable this ONLY for debugging

    // our Console, clear the variables for neatness
VAR testconsole:    Console := NIL;
    testsurface:    Surface := NIL;
    frames:     dword := 0;

FUNCTION RGB32(r,g,b:byte):dword;
VAR temp:dword;
BEGIN
  ASM
    mov  ah,   [r]
    mov  al,   [g]
    mov  cl,   [b]
    and  eax,  $0000ffff
    shl  eax,  8
    mov  al,   cl
    mov  [temp], eax
  END;
  result := temp;
END;

    // set textmode
PROCEDURE set_textmode; assembler;
ASM
  mov  ax,  $03
  int  $10
END;

        // -------------- START OF MAIN CODE ----------------

begin
    // We will use the VBEConsole to display the image, therefore we overload
    // the testconsole type when creating it (creating means allocating)
    // (if debug_wrapper is defined, wrap VBEConsole to wrapper
  {$IFNDEF debug_wrapper}
    new(VBEConsole(testconsole),Create);
  {$ELSE}
    new(TTYConsole(testconsole),Create);
    DECLARE VAR deb: Console;
    BEGIN
      new(VBEConsole(deb),Create);
      testconsole^.Wrap(deb);
    END;
  {$ENDIF}

    // read options into Console, which will be used instead of the default
    // values if specified (here we load options from "mtc.cfg")
  testconsole^.getOptions(mtc_option_file);

    // options are set, and we can safely proceed opening our Console.
  testconsole^.Open('muuTC test',0,0,Format(Unknown));

    // check if an error occurred when opening, and exit with error if so
  IF (testconsole^.Error) THEN
    fail('Failed to create console');

    // create Surface and draw nice colors to it
  testsurface := Surface(testconsole^.Info.Width,testconsole^.Info.Height,Format(BGR8888));
  DECLARE VAR x,y:  dword := 0;
    FOR y := 0 TO (testsurface^.Height-1) DO
      FOR x := 0 TO (testsurface^.Width-1) DO
        memd[ofs(testsurface^.Data^)+(x+y*testsurface^.Width)*Pitch(testsurface)] := RGB32(round((255/testsurface^.Width)*-x),round((255/testsurface^.Height)*-y),round((255/testsurface^.Width)*x));

  testconsole^.Copy(0,0,testsurface,Area(testsurface));
  testconsole^.Update;
  readkey;

    // clear keyboard buffer
  WHILE (keypressed) DO readkey;

    // close Console and free that one, too
  testconsole^.Close;
  dispose(testconsole,Destroy);

    // set textmode
  set_textmode;

  writeln('muu TrueColor library for TMT Pascal - muuTC test program');
  writeln('Copyright (C) 1999 Tor Arne Gustad (anden@online.no)');
end.
