    // mmx add pixels
PROCEDURE mmx_add_pixels(m_put:muuPutInterface); assembler;
  VAR tr_height:    dword := m_put^.Height;
      tr_width:     dword := m_put^.Width;
      tr_src:       pointer := m_put^.Source.Data;
      tr_dest:      pointer := m_put^.Destination.Data;
      tr_srcnl:     dword := m_put^.Source.Width;
      tr_destnl:    dword := m_put^.Destination.Width;
ASM
    mov  edx,   tr_height
    mov  esi,   tr_src
    mov  edi,   tr_dest
    sub  esi,   8
    sub  edi,   8

  @@line_loop:
    mov  ecx,   tr_width
    shr  ecx,   1
    jz   @@single_pixel

    // move 2 pixels per loop
  @@pixel_loop:
    movq mm0,   QWORD [esi+ecx*8]
    movq mm1,   QWORD [edi+ecx*8]
    paddusb mm0,mm1
    movq QWORD  [edi+ecx*8],  mm0

    dec  ecx
    jnz  @@pixel_loop

    // move 1 pixel per loop
  @@single_pixel:
{    mov  ecx,   tr_width
    test ecx,   $01
    jz   @@next_line
    inc  ecx
    movd mm0,   DWORD [esi+ecx*4]
    movd mm1,   DWORD [edi+ecx*4]
    paddusb mm0,mm1
    movd DWORD [edi+ecx*4],  mm0}

    // go to next line
  @@next_line:
    add  esi,   tr_srcnl
    add  edi,   tr_destnl
    dec  edx
    jnz  @@line_loop

    emms
END;

    // mmx subtract pixels
PROCEDURE mmx_sub_pixels(m_put:muuPutInterface); assembler;
  VAR tr_height:    dword := m_put^.Height;
      tr_width:     dword := m_put^.Width;
      tr_src:       pointer := m_put^.Source.Data;
      tr_dest:      pointer := m_put^.Destination.Data;
      tr_srcnl:     dword := m_put^.Source.Width;
      tr_destnl:    dword := m_put^.Destination.Width;
ASM
    mov  edx,   tr_height
    mov  esi,   tr_src
    mov  edi,   tr_dest
    sub  esi,   8
    sub  edi,   8

  @@line_loop:
    mov  ecx,   tr_width
    shr  ecx,   1
    jz   @@single_pixel

    // move 2 pixels per loop
  @@pixel_loop:
    movq mm1,   QWORD [esi+ecx*8]
    movq mm0,   QWORD [edi+ecx*8]
    psubusb mm0,mm1
    movq QWORD  [edi+ecx*8],  mm0

    dec  ecx
    jnz  @@pixel_loop

    // move 1 pixel per loop
  @@single_pixel:
    mov  ecx,   tr_width
    test ecx,   $01
    jz   @@next_line
    inc  ecx
    movd mm0,   DWORD [esi+ecx*4]
    movd mm1,   DWORD [edi+ecx*4]
    psubusb mm0,mm1
    movd DWORD [edi+ecx*4],  mm0

    // go to next line
  @@next_line:
    add  esi,   tr_srcnl
    add  edi,   tr_destnl
    dec  edx
    jnz  @@line_loop

    emms
END;

    // mmx add grade
PROCEDURE mmx_add_grade(m_put:muuPutInterface); assembler;
  VAR tr_height:    dword := m_put^.Height;
      tr_width:     dword := m_put^.Width;
      tr_src:       pointer := m_put^.Source.Data;
      tr_dest:      pointer := m_put^.Destination.Data;
      tr_srcnl:     dword := m_put^.Source.Width;
      tr_destnl:    dword := m_put^.Destination.Width;
      g:            byte := m_put^.Grade;
      mmfill:       ARRAY[0..1] OF dword;
ASM
    mov  edi,  OFFSET mmfill
    add  edi,  ebp
    mov  al,   g
    mov  ecx,  7
    rep  stosb
    movq mm2,  [mmfill]

    mov  edx,   tr_height
    mov  esi,   tr_src
    mov  edi,   tr_dest
    sub  esi,   8
    sub  edi,   8

  @@line_loop:
    mov  ecx,   tr_width
    shr  ecx,   1
    jz   @@single_pixel

    // move 2 pixels per loop
  @@pixel_loop:
    movq mm0,   QWORD [esi+ecx*8]
    movq mm1,   QWORD [edi+ecx*8]
    psubusb mm0,mm2
    paddusb mm0,mm1
    movq QWORD  [edi+ecx*8],  mm0

    dec  ecx
    jnz  @@pixel_loop

    // move 1 pixel per loop
  @@single_pixel:
    mov  ecx,   tr_width
    test ecx,   $01
    jz   @@next_line
    inc  ecx
    movd mm0,   DWORD [esi+ecx*4]
    movd mm1,   DWORD [edi+ecx*4]
    paddusb mm0,mm1
    movd DWORD [edi+ecx*4],  mm0

    // go to next line
  @@next_line:
    add  esi,   tr_srcnl
    add  edi,   tr_destnl
    dec  edx
    jnz  @@line_loop

    emms
END;

