{
   muu TrueColor library for TMT Pascal - Nova clearer routines
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

PROCEDURE Nx86_CLEAR_4BYTE(tgt:pointer;col,wdt,hgt,nl:dword); assembler;
ASM
    mov  edi, tgt   // target
    mov  esi, hgt   // height
    mov  eax, col   // color
    
@@line_loop:
    mov  ecx, wdt   // width

    rep  stosd

    add  edi, nl    // next line
    dec  esi
    jnz  @@line_loop
END;

PROCEDURE Nx86_CLEAR_3BYTE(tgt:pointer;col,wdt,hgt,nl:dword); assembler;
ASM
    mov  edi, tgt   // target
    mov  esi, hgt   // height
    mov  eax, col   // color
    mov  dx,  ax
    shr  eax, 16

@@line_loop:
    mov  ecx, wdt   // width
    
@@pixel_loop:
    mov  [edi],  dx
    mov  [edi+2], al
    
    add  edi, 3
    dec  ecx
    jnz  @@pixel_loop

    add  edi, nl    // next line
    dec  esi
    jnz  @@line_loop
END;

PROCEDURE Nx86_CLEAR_2BYTE(tgt:pointer;col,wdt,hgt,nl:dword); assembler;
ASM
    mov  edi, tgt   // target
    mov  esi, hgt   // height
    mov  eax, col   // color

    
    
@@line_loop:
    mov  ecx, wdt   // width
    rep  stosw

    add  edi, nl    // next line
    dec  esi
    jnz  @@line_loop
END;

PROCEDURE Nx86_CLEAR_1BYTE(tgt:pointer;col,wdt,hgt,nl:dword); assembler;
ASM
    mov  edi, tgt   // target
    mov  esi, hgt   // height
    mov  eax, col   // color

@@line_loop:
    mov  ecx, wdt   // width
    rep  stosb

    add  edi, nl    // next line
    dec  esi
    jnz  @@line_loop
END;
