{
   muu TrueColor library for TMT Pascal - Nova 32bpp->X dithering routines
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

PROCEDURE Dx86_S32_D8(src,tgt:pointer;wdt,hgt,snl,tnl:dword); assembler;
{ VAR ypos,xpos: dword;
     put_val:      byte;
  FOR ypos := 0 TO (hgt-1) DO
  BEGIN
    FOR xpos := 0 TO (wdt-1) DO
    BEGIN
      put_val := DitherTab_b332_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)]];
      put_val := put_val OR DitherTab_g332_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)+1]];
      put_val := put_val OR DitherTab_r332_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)+2]];
      
      mem[ofs(tgt^)+xpos] := put_val;
    END;
    src := ptr(ofs(src^)+snl+wdt*4);
    tgt := ptr(ofs(tgt^)+tnl+wdt);
  END;}
  VAR dtab_b: pointer := ptr(ofs(DitherTab_b332_44));
      dtab_g: pointer := ptr(ofs(DitherTab_g332_44));
      dtab_r: pointer := ptr(ofs(DitherTab_r332_44));
      y_pos:  dword;
ASM
    mov  esi, src   // source
    mov  edi, tgt   // target
    mov  edx, hgt   // height

@@line_loop:
    mov  ecx, wdt   // width
    push edx

        // ypos*256 = ypos<<8
    and  edx, $03   // ypos AND $03
    shl  edx, 8     // ypos SHL 8
    mov  y_pos, edx

        // linear:  [xpos*256*4+ypos*256+pixel]
    
@@pixel_loop:

        // xpos*256*4 = xpos<<10
    mov  ebx, ecx
    and  ebx, $03   // xpos AND $03
    shl  ebx, 10    // xpos SHL 10
    add  ebx, y_pos
      
        // blue color
    push ebx
    xor  edx, edx
    mov  dl,  [esi]
    add  ebx, edx   // [xpos,ypos,src[x]]
    mov  edx, dtab_b
    mov  al,  [edx+ebx]
    pop  ebx

        // green color
    push ebx
    xor  edx, edx
    mov  dl,  [esi+1]
    add  ebx, edx   // [xpos,ypos,src[x+1]]
    mov  edx, dtab_g
    or   al,  [edx+ebx]
    pop  ebx

        // red color
    push ebx
    xor  edx, edx
    mov  dl,  [esi+2]
    add  ebx, edx   // [xpos,ypos,src[x+2]]
    mov  edx, dtab_r
    or   al,  [edx+ebx]
    pop  ebx
 
    mov  [edi],  al

    add  esi, 4
    add  edi, 1

    dec  ecx
    jnz  @@pixel_loop

    add  esi, snl
    add  edi, tnl

    pop  edx
    dec  edx
    jnz  @@line_loop
END;


PROCEDURE Dx86_S32_D15(src,tgt:pointer;wdt,hgt,snl,tnl:dword); assembler;
{ VAR ypos,xpos: dword;
     put_val:      word;   
  FOR ypos := 0 TO (hgt-1) DO
  BEGIN
    FOR xpos := 0 TO (wdt-1) DO
    BEGIN
      put_val := DitherTab_b565_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)]];
      put_val := put_val OR ((DitherTab_g565_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)+1]] AND $7C0) SHR 1);
      put_val := put_val OR (DitherTab_r565_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)+2]] SHR 1);
      
      memw[ofs(tgt^)+xpos*2] := put_val;
    END;
    src := ptr(ofs(src^)+snl+wdt*4);
    tgt := ptr(ofs(tgt^)+tnl+wdt*2);
  END;
}
  VAR dtab_b: pointer := ptr(ofs(DitherTab_b565_44));
      dtab_g: pointer := ptr(ofs(DitherTab_g565_44));
      dtab_r: pointer := ptr(ofs(DitherTab_r565_44));
      y_pos:  dword;
ASM
    mov  esi, src   // source
    mov  edi, tgt   // target
    mov  edx, hgt   // height
    
@@line_loop:
    mov  ecx, wdt   // width
    push edx

        // ypos*256 = ypos<<8
    and  edx, $03   // ypos AND $03
    shl  edx, 8     // ypos SHL 8
    mov  y_pos, edx

        // linear:  [xpos*256*4+ypos*256+pixel]
    
@@pixel_loop:

        // xpos*256*4 = xpos<<10
    mov  ebx, ecx
    and  ebx, $03   // xpos AND $03
    shl  ebx, 10    // xpos SHL 10
    add  ebx, y_pos
      
        // blue color
    push ebx
    xor  edx, edx
    mov  dl,  [esi]
    add  ebx, edx   // [xpos,ypos,src[x]]
    mov  edx, dtab_b
    mov  ax,  [edx+ebx*2]
    pop  ebx

        // green color
    push ebx
    xor  edx, edx
    mov  dl,  [esi+1]
    add  ebx, edx   // [xpos,ypos,src[x+1]]
    mov  edx, dtab_g
    mov  dx,  [edx+ebx*2]
    and  dx,  $7C0
    shr  dx,  1
    or   ax,  dx
    pop  ebx

        // red color
    push ebx
    xor  edx, edx
    mov  dl,  [esi+2]
    add  ebx, edx   // [xpos,ypos,src[x+2]]
    mov  edx, dtab_r
    mov  dx,  [edx+ebx*2]
    shr  dx,  1
    or   ax,  dx
    pop  ebx
 
    mov  [edi],  ax

    add  esi, 4
    add  edi, 2

    dec  ecx
    jnz  @@pixel_loop

    add  esi, snl
    add  edi, tnl

    pop  edx
    dec  edx
    jnz  @@line_loop
END;

PROCEDURE Dx86_S32_D16(src,tgt:pointer;wdt,hgt,snl,tnl:dword); assembler;
{ VAR ypos,xpos: dword;
     put_val:      word;   
  FOR ypos := 0 TO (hgt-1) DO
  BEGIN
    FOR xpos := 0 TO (wdt-1) DO
    BEGIN
      put_val := DitherTab_b565_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)]];
      put_val := put_val OR DitherTab_g565_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)+1]];
      put_val := 0;
      put_val := put_val OR DitherTab_r565_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)+2]];
      
      memw[ofs(tgt^)+xpos*2] := put_val;
    END;
    src := ptr(ofs(src^)+snl+wdt*4);
    tgt := ptr(ofs(tgt^)+tnl+wdt*2);
  END;}
  VAR dtab_b: pointer := ptr(ofs(DitherTab_b565_44));
      dtab_g: pointer := ptr(ofs(DitherTab_g565_44));
      dtab_r: pointer := ptr(ofs(DitherTab_r565_44));
      y_pos:  dword;
ASM
    mov  esi, src   // source
    mov  edi, tgt   // target
    mov  edx, hgt   // height

@@line_loop:
    mov  ecx, wdt   // width
    push edx

        // ypos*256 = ypos<<8
    and  edx, $03   // ypos AND $03
    shl  edx, 8     // ypos SHL 8
    mov  y_pos, edx

        // linear:  [xpos*256*4+ypos*256+pixel]

@@pixel_loop:

        // xpos*256*4 = xpos<<10
    mov  ebx, ecx
    and  ebx, $03   // xpos AND $03
    shl  ebx, 10    // xpos SHL 10
    add  ebx, y_pos
      
        // blue color
    push ebx
    xor  edx, edx
    mov  dl,  [esi]
    add  ebx, edx   // [xpos,ypos,src[x]]
    mov  edx, dtab_b
    mov  ax,  [edx+ebx*2]
    pop  ebx

        // green color
    push ebx
    xor  edx, edx
    mov  dl,  [esi+1]
    add  ebx, edx   // [xpos,ypos,src[x+1]]
    mov  edx, dtab_g
    or   ax,  [edx+ebx*2]
    pop  ebx

        // red color
    push ebx
    xor  edx, edx
    mov  dl,  [esi+2]
    add  ebx, edx   // [xpos,ypos,src[x+2]]
    mov  edx, dtab_r
    or   ax,  [edx+ebx*2]
    pop  ebx
 
    mov  [edi],  ax

    add  esi, 4
    add  edi, 2

    dec  ecx
    jnz  @@pixel_loop

    add  esi, snl
    add  edi, tnl

    pop  edx
    dec  edx
    jnz  @@line_loop
END;


PROCEDURE Dx86_S32_D8_SWAP_RB(src,tgt:pointer;wdt,hgt,snl,tnl:dword); assembler;
{ VAR ypos,xpos: dword;
     put_val:      byte;
  FOR ypos := 0 TO (hgt-1) DO
  BEGIN
    FOR xpos := 0 TO (wdt-1) DO
    BEGIN
      put_val := DitherTab_r332_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)]];
      put_val := put_val OR DitherTab_g332_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)+1]];
      put_val := put_val OR DitherTab_b332_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)+2]];
      
      mem[ofs(tgt^)+xpos] := put_val;
    END;
    src := ptr(ofs(src^)+snl+wdt*4);
    tgt := ptr(ofs(tgt^)+tnl+wdt);
  END;}
  VAR dtab_b: pointer := ptr(ofs(DitherTab_r332_44));
      dtab_g: pointer := ptr(ofs(DitherTab_g332_44));
      dtab_r: pointer := ptr(ofs(DitherTab_b332_44));
      y_pos:  dword;
ASM
    mov  esi, src   // source
    mov  edi, tgt   // target
    mov  edx, hgt   // height

    
    
@@line_loop:
    mov  ecx, wdt   // width
    push edx

        // ypos*256 = ypos<<8
    and  edx, $03   // ypos AND $03
    shl  edx, 8     // ypos SHL 8
    mov  y_pos, edx

        // linear:  [xpos*256*4+ypos*256+pixel]
    
@@pixel_loop:

        // xpos*256*4 = xpos<<10
    mov  ebx, ecx
    and  ebx, $03   // xpos AND $03
    shl  ebx, 10    // xpos SHL 10
    add  ebx, y_pos
      
        // blue color
    push ebx
    xor  edx, edx
    mov  dl,  [esi]
    add  ebx, edx   // [xpos,ypos,src[x]]
    mov  edx, dtab_b
    mov  al,  [edx+ebx]
    pop  ebx

        // green color
    push ebx
    xor  edx, edx
    mov  dl,  [esi+1]
    add  ebx, edx   // [xpos,ypos,src[x+1]]
    mov  edx, dtab_g
    or   al,  [edx+ebx]
    pop  ebx

        // red color
    push ebx
    xor  edx, edx
    mov  dl,  [esi+2]
    add  ebx, edx   // [xpos,ypos,src[x+2]]
    mov  edx, dtab_r
    or   al,  [edx+ebx]
    pop  ebx
 
    mov  [edi],  al

    add  esi, 4
    add  edi, 1

    dec  ecx
    jnz  @@pixel_loop

    add  esi, snl
    add  edi, tnl

    pop  edx
    dec  edx
    jnz  @@line_loop
END;

PROCEDURE Dx86_S32_D15_SWAP_RB(src,tgt:pointer;wdt,hgt,snl,tnl:dword); assembler;
{ VAR ypos,xpos: dword;
     put_val:      word;   
  FOR ypos := 0 TO (hgt-1) DO
  BEGIN
    FOR xpos := 0 TO (wdt-1) DO
    BEGIN
      put_val := DitherTab_r565_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)]];
      put_val := put_val OR ((DitherTab_g565_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)+1]] AND $7C0) SHR 1);
      put_val := put_val OR (DitherTab_b565_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)+2]] SHR 1);
      
      memw[ofs(tgt^)+xpos*2] := put_val;
    END;
    src := ptr(ofs(src^)+snl+wdt*4);
    tgt := ptr(ofs(tgt^)+tnl+wdt*2);
  END;
}
  VAR dtab_b: pointer := ptr(ofs(DitherTab_r565_44));
      dtab_g: pointer := ptr(ofs(DitherTab_g565_44));
      dtab_r: pointer := ptr(ofs(DitherTab_b565_44));
      y_pos:  dword;
ASM
    mov  esi, src   // source
    mov  edi, tgt   // target
    mov  edx, hgt   // height

    
    
@@line_loop:
    mov  ecx, wdt   // width
    push edx

        // ypos*256 = ypos<<8
    and  edx, $03   // ypos AND $03
    shl  edx, 8     // ypos SHL 8
    mov  y_pos, edx

        // linear:  [xpos*256*4+ypos*256+pixel]
    
@@pixel_loop:

        // xpos*256*4 = xpos<<10
    mov  ebx, ecx
    and  ebx, $03   // xpos AND $03
    shl  ebx, 10    // xpos SHL 10
    add  ebx, y_pos
      
        // blue color
    push ebx
    xor  edx, edx
    mov  dl,  [esi]
    add  ebx, edx   // [xpos,ypos,src[x]]
    mov  edx, dtab_b
    mov  ax,  [edx+ebx*2]
    pop  ebx

        // green color
    push ebx
    xor  edx, edx
    mov  dl,  [esi+1]
    add  ebx, edx   // [xpos,ypos,src[x+1]]
    mov  edx, dtab_g
    mov  dx,  [edx+ebx*2]
    and  dx,  $7C0
    shr  dx,  1
    or   ax,  dx
    pop  ebx

        // red color
    push ebx
    xor  edx, edx
    mov  dl,  [esi+2]
    add  ebx, edx   // [xpos,ypos,src[x+2]]
    mov  edx, dtab_r
    mov  dx,  [edx+ebx*2]
    shr  dx,  1
    or   ax,  dx
    pop  ebx
 
    mov  [edi],  ax

    add  esi, 4
    add  edi, 2

    dec  ecx
    jnz  @@pixel_loop

    add  esi, snl
    add  edi, tnl

    pop  edx
    dec  edx
    jnz  @@line_loop
END;

PROCEDURE Dx86_S32_D16_SWAP_RB(src,tgt:pointer;wdt,hgt,snl,tnl:dword); assembler;
{ VAR ypos,xpos: dword;
     put_val:      word;   
  FOR ypos := 0 TO (hgt-1) DO
  BEGIN
    FOR xpos := 0 TO (wdt-1) DO
    BEGIN
      put_val := DitherTab_r565_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)]];
      put_val := put_val OR DitherTab_g565_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)+1]];
      put_val := put_val OR DitherTab_b565_44[xpos AND $03,ypos AND $03,mem[ofs(src^)+(xpos shl 2)+2]];
      
      memw[ofs(tgt^)+xpos*2] := put_val;
    END;
    src := ptr(ofs(src^)+snl+wdt*4);
    tgt := ptr(ofs(tgt^)+tnl+wdt*2);
  END;}
  VAR dtab_b: pointer := ptr(ofs(DitherTab_r565_44));
      dtab_g: pointer := ptr(ofs(DitherTab_g565_44));
      dtab_r: pointer := ptr(ofs(DitherTab_b565_44));
      y_pos:  dword;
ASM
    mov  esi, src   // source
    mov  edi, tgt   // target
    mov  edx, hgt   // height
    
@@line_loop:
    mov  ecx, wdt   // width
    push edx

        // ypos*256 = ypos<<8
    and  edx, $03   // ypos AND $03
    shl  edx, 8     // ypos SHL 8
    mov  y_pos, edx

        // linear:  [xpos*256*4+ypos*256+pixel]

@@pixel_loop:

        // xpos*256*4 = xpos<<10
    mov  ebx, ecx
    and  ebx, $03   // xpos AND $03
    shl  ebx, 10    // xpos SHL 10
    add  ebx, y_pos
      
        // blue color
    push ebx
    xor  edx, edx
    mov  dl,  [esi]
    add  ebx, edx   // [xpos,ypos,src[x]]
    mov  edx, dtab_b
    mov  ax,  [edx+ebx*2]
    pop  ebx

        // green color
    push ebx
    xor  edx, edx
    mov  dl,  [esi+1]
    add  ebx, edx   // [xpos,ypos,src[x+1]]
    mov  edx, dtab_g
    or   ax,  [edx+ebx*2]
    pop  ebx

        // red color
    push ebx
    xor  edx, edx
    mov  dl,  [esi+2]
    add  ebx, edx   // [xpos,ypos,src[x+2]]
    mov  edx, dtab_r
    or   ax,  [edx+ebx*2]
    pop  ebx
 
    mov  [edi],  ax

    add  esi, 4
    add  edi, 2

    dec  ecx
    jnz  @@pixel_loop

    add  esi, snl
    add  edi, tnl

    pop  edx
    dec  edx
    jnz  @@line_loop
END;


