{
   muu TrueColor library for TMT Pascal - Surface RAW file loader
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.       
}

UNIT mRAW;

INTERFACE
{$R-,I+,Q-}

USES mFormat,mSurface,Error;


//---------------------------------------------------------------------------
    // CRS sprite loader

FUNCTION loadRAW_open(fname:string;m_width,m_height:word;m_format:Format): Surface;
FUNCTION loadRAW_open_part(fname:string;m_width,m_height:word;m_format:Format;m_start:dword): Surface;
  OVERLOAD loadRAW = loadRAW_open;
  OVERLOAD loadRAW = loadRAW_open_part;

//---------------------------------------------------------------------------
IMPLEMENTATION

    // ("FILENAME",SKIP_BYTES,READ_BYTES,^DATA)
PROCEDURE read_from_file(fn:string;sb,rb:dword;VAR m_data:pointer);
  VAR f:    file;
BEGIN
  assign(f,fn);
  {$I-} reset(f,1); {$I+}
  IF (IOResult <> 0) THEN
    fail('RAW file not found ("'+fn+'")');

  seek(f,sb);
  IF (rb > (filesize(f)-sb)) THEN
    rb := filesize(f)-sb;
  blockread(f,m_data^,rb);

  close(f);
END;

FUNCTION loadRAW_open;
BEGIN
  result := Surface(m_width,m_height,m_format);
  read_from_file(fname,0,result^.Size,result^.Data);
END;

FUNCTION loadRAW_open_part;
BEGIN
  result := Surface(m_width,m_height,m_format);
  read_from_file(fname,m_start,result^.Size,result^.Data);
END;


end.
